## EExtension

EExtension — abstract base class for extensions

## Synopsis

    #include <e-util/e-extension.h>

                        EExtension;
    EExtensible *       e_extension_get_extensible          (EExtension *extension);

## Object Hierarchy

      GObject
       +----EExtension
             +----EShellBackend

## Properties

      "extensible"               EExtensible*          : Read / Write / Construct Only

## Description

EExtension provides a way to extend the functionality of objects that implement the EExtensible interface. EExtension subclasses can target a particular extensible object type. New instances of an extensible object type get paired with a new instance of each EExtension subclass that targets the extensible object type.

The first steps of writing a new extension are as follows:

1. Subclass EExtension.

2. In the class initialization function, specify the GType being extended. The GType must implement the EExtensible interface.

3. Register the extension's own GType. If the extension is to be loaded dynamically using GTypeModule, the type should be registered in the library module's `e_module_load()` function.

## Details

### EExtension

    typedef struct _EExtension EExtension;

Contains only private data that should be read and manipulated using the functions below.

### e_extension_get_extensible ()

    EExtensible *       e_extension_get_extensible          (EExtension *extension);

Returns the object that `extension` extends.

`extension` : | an EExtension
Returns : | the object being extended

## Property Details

### The `"extensible"` property

      "extensible"               EExtensible*          : Read / Write / Construct Only

The object being extended.